
ELF_PREREQUISITES = a.o b.o c.o

all: x.elf
	@head -n 1 x.elf

clean:
	@rm -f *.o
	@rm -f *.c
	@rm -f *.h
	@rm -f x.elf

init: clean
	@echo creating a.c b.c c.c version.h
	@echo "cat version.h" > a.c
	@echo "echo "bbbb"" > b.c
	@echo "echo "cccc"" > c.c
	@echo "#define VERSION 123" > version.h

version.timestamp: ${ELF_PREREQUISITES}
	@echo updating version.timestamp and timestamping version.h as current
	@touch version.timestamp
	@touch version.h

x.elf: ${ELF_PREREQUISITES}
	@echo linking
	@cat $< > $@
	@echo incrementing version
	@if [ ! -f version_current.h ]; then                     \
	echo "File version_current.h not found - creating";      \
	echo "0" > version_current.h;                            \
        fi
	@read LASTNUM < version_current.h;                       \
	NEWNUM=$$(($$LASTNUM + 1));                              \
	echo "$$NEWNUM" > version_current.h;                     \
	echo "#define VERSION $$NEWNUM" > version.h 
	@echo timestamping version.h artificially as old
	@touch -t 200001010000 version.h

%.o: %.c
	@echo making $@ from $<
	@sh $< > $@


# phonies not ponies :-)
.PHONY: all clean init


# disable implicit rules
.SUFFIXES:



# following comes from the automatic dependency generated by preprocessor
a.o: a.c version.h

version.h:
